
load("data/nlist.RData")

tmp=nlist[["sim_4_rep_11_size_50"]]

net <- as.network(imputed_mice[["sim_4_rep_11_size_50_mech_mar_prop_l_tp_mix_method_mice_num_avg"]]) #
set.vertex.attribute(net, "va", tmp$va)
set.vertex.attribute(net, "vb", tmp$vb)
set.vertex.attribute(net, "vc", tmp$vc)

m1 <- summary(ergm(net ~ edges + mutual + gwesp(0.5, fixed=T) + nodematch("vb") + nodematch("vc") + nodecov("va") + nodefactor("vb") + nodecov("vc")))
m1


# 
# net <- as.network(cf_data$cf_friend_directed) #
# set.vertex.attribute(net, "va", cf_data$cf_nodal_cov$age)
# set.vertex.attribute(net, "vb", cf_data$cf_nodal_cov$gender)
# set.vertex.attribute(net, "vc", cf_data$cf_nodal_cov$personality1)
# 
# m1 <- summary(ergm(net ~ edges + mutual + nodematch("vb") + nodematch("vc") + nodecov("va") + nodefactor("vb") + nodecov("vc")))
# m1


source("result_funcs.R")


### network descriptives


repnum=100
sim<-c(1:4)
rep<-c(1:repnum)
ssize<-c(50, 100)

cond <-list(
  ssize=ssize, sim=sim, rep=rep
)

allcond <- expand.grid(cond)
res_complete<-allcond
for (i in 1:nrow(allcond)){
  print(i)
  tmp<-allcond[i,]
  sim<-tmp$sim
  ssize<-as.numeric(tmp$ssize)
  rep<-tmp$rep

  nname<-paste0("sim_", sim, "_rep_", rep, "_size_", ssize)
  
  nnet<-nlist[[nname]]
 
  
  stats<-netstats(nnet$adj_matrix, nnet$va, nnet$vb, nnet$vc)
  res_complete[i, "density"]<-stats[["density"]]
  res_complete[i, "reciprocity"]<-stats[["reciprocity"]]
  res_complete[i, "gwesp"]<-stats[["gwesp"]]
  res_complete[i, "triangle"]<-stats[["triangle"]]
  res_complete[i, "transitivity"]<-stats[["transitivity"]]
  res_complete[i, "homophilyA"]<-stats[["homophilyA"]]
  res_complete[i, "homophilyB"]<-stats[["homophilyB"]]
  res_complete[i, "homophilyC"]<-stats[["homophilyC"]]
  
  
}


## check autocorrelation

library(tseries)

for (trait in c('density','reciprocity', 'gwesp', 'homophilyA', 'homophilyB', 'homophilyC')){
  print(acf(res_complete[res_complete$sim==1 & res_complete$ssize==50, trait], plot=F))
  print(acf(res_complete[res_complete$sim==1 & res_complete$ssize==100, trait], plot=F))
  print(acf(res_complete[res_complete$sim==2 & res_complete$ssize==50, trait], plot=F))
        print(acf(res_complete[res_complete$sim==2 & res_complete$ssize==100, trait], plot=F))
              print(acf(res_complete[res_complete$sim==3 & res_complete$ssize==50, trait], plot=F))
                    print(acf(res_complete[res_complete$sim==3 & res_complete$ssize==100, trait], plot=F))
                          print(acf(res_complete[res_complete$sim==4 & res_complete$ssize==50, trait], plot=F))
                                print(acf(res_complete[res_complete$sim==4 & res_complete$ssize==100, trait], plot=F))
  
}

 # View(res_complete[res_complete$sim==4, ])
 #View(res_complete[res_complete$density>0.5,])

library(dplyr)
res_complete %>%  group_by(sim, ssize) %>% summarize(density=mean(density), triangle=mean(triangle), gwesp=mean(gwesp),"reciprocity"=mean(reciprocity), homophilyA=mean(homophilyA), "homophilyB"=mean(homophilyB), "homophilyC"=mean(homophilyC), "triangles"=mean(triangle), "transitivity"=mean(transitivity)) 


save(res_complete, file="data/res_complete.RData")


load("data/res_complete.RData")



for (i in 1:nrow(res_complete)){
  print(i)
  tmp<-res_complete[i,]
  sim<-tmp$sim
  ssize<-as.numeric(tmp$ssize)
  rep<-tmp$rep
  
  nname<-paste0("sim_", sim, "_rep_", rep, "_size_", ssize)
  
  nnet<-nlist[[nname]]
  
  
  coef<-ergmcoef(nnet$adj_matrix, nnet$va, nnet$vb, nnet$vc)
  res_complete[i, "c_edges"]<-coef[["edges"]]
  res_complete[i, "c_mutual"]<-coef[["mutual"]]
  res_complete[i, "c_gwesp"]<-coef[["gwesp"]]
  res_complete[i, "c_nodematchB"]<-coef[["nodematchB"]]
  res_complete[i, "c_nodematchC"]<-coef[["nodematchC"]]
  res_complete[i, "c_nodecovA"]<-coef[["nodecovA"]]
  res_complete[i, "c_nodefactorB2"]<-coef[["nodefactorB2"]]
  res_complete[i, "c_nodecovC"]<-coef[["nodecovC"]]
  
  
}


library(dplyr)
res_complete %>%  group_by(sim, ssize) %>% summarize(edges=mean(c_edges), gwesp=mean(c_gwesp),"mutual"=mean(c_mutual), "nodematchB"=mean(c_nodematchB), "nodematchC"=mean(c_nodematchC), "nodecovA"=mean(c_nodecovA), "nodefactorB"=mean(c_nodefactorB2), "nodecovC"=mean(c_nodecovC)) %>% View()

save(res_complete, file="data/res_complete.RData")

write.csv(res_complete, "data/res_complete.csv")
