
load("data/nlist.RData")
load("data/imputed_bergm2.RData")

source("result_funcs.R")

### imputation

repnum=100
sim<-c(1:4)
rep<-c(1:repnum)
mech<-c("mcar", "mar", "mnar1", "mnar2")
prop<-c(0.1, 0.2, 0.3)
tp<-c("actor","cell","mix")
ssize=c(50,100)
imp_method<-c("bergm2")
imp_num<-c("avg")

cond <-list(
  ssize=ssize, sim=sim, rep=rep, mech=mech, prop=prop, tp=tp, imp_method=imp_method, imp_num=imp_num
)

allcond <- expand.grid(cond)




arg<-as.numeric(commandArgs(trailingOnly=TRUE))

intvs=96
seps=intvs+1
intvstarts=(seq(0, nrow(allcond), len=seps)+1)[1:intvs]
intvends=(seq(0, nrow(allcond), len=seps))[2:seps]



### p is interval index
### for i in (intvstarts[p]:intvends[p])

coef_bergm2<-allcond
for (i in intvstarts[arg]:intvends[arg]){
  tmp<-allcond[i,]
  sim<-tmp$sim
  mech<-tmp$mech
  prop<-as.numeric(tmp$prop)
  tp<-tmp$tp
  ssize<-as.numeric(tmp$ssize)
  rep<-tmp$rep
  imp_method<-tmp$imp_method
  imp_num<-tmp$imp_num
  propname<-ifelse(prop==0.1, "l", ifelse(prop==0.2, "m", "h"))
  
  nname<-paste0("sim_", sim, "_rep_", rep, "_size_", ssize)
  impname<-paste0("sim_", sim, "_rep_", rep, "_size_", ssize, "_mech_", mech, "_prop_", propname, "_tp_", tp, "_method_", imp_method, "_num_", imp_num)
  
  comp <-nlist[[nname]]
  imputed<-imputed_bergm2[[impname]]
  coef<-ergmcoef(imputed, comp$va, comp$vb, comp$vc)
  coef_bergm2[i, "edges"]<-coef[["edges"]]
  coef_bergm2[i, "mutual"]<-coef[["mutual"]]
  coef_bergm2[i, "gwesp"]<-coef[["gwesp"]]
  coef_bergm2[i, "nodematchB"]<-coef[["nodematchB"]]
  coef_bergm2[i, "nodematchC"]<-coef[["nodematchC"]]
  coef_bergm2[i, "nodecovA"]<-coef[["nodecovA"]]
  coef_bergm2[i, "nodefactorB2"]<-coef[["nodefactorB2"]]
  coef_bergm2[i, "nodecovC"]<-coef[["nodecovC"]]
}

coef_bergm2_sep<-coef_bergm2[intvstarts[arg]:intvends[arg],]

save(coef_bergm2_sep, file=paste0("data/seps/coef_bergm2_",arg,".RData"))


library(dplyr)
coef_bergm2_sep %>%  group_by(sim, ssize) %>% summarize(edges=mean(edges), gwesp=mean(gwesp),"mutual"=mean(mutual), "nodematchB"=mean(nodematchB), "nodematchC"=mean(nodematchC), "nodecovA"=mean(nodecovA), "nodefactorB"=mean(nodefactorB2), "nodecovC"=mean(nodecovC)) 


coef_bergm2<-data.frame()
for (i in 1:96){
  load(paste0("data/seps/coef_bergm2_",i,".RData"))
  coef_bergm2<-rbind(coef_bergm2, coef_bergm2_sep)
}
save(coef_bergm2, file="data/coef_bergm2.RData")
