
source("result_funcs.R")

load("data/mlist.RData")





repnum=100
sim<-c(1:4)
rep<-c(1:repnum)
mech<-c("mcar", "mar", "mnar1", "mnar2")
prop<-c(0.1, 0.2, 0.3)
tp<-c("actor","cell","mix")
ssize=c(50,100)

cond <-list(
ssize=ssize, sim=sim, rep=rep, mech=mech, prop=prop, tp=tp
)

allcond <- expand.grid(cond)

mlist_coefs<-allcond

arg<-as.numeric(commandArgs(trailingOnly=TRUE))
intvs=72
seps=intvs+1
intvstarts=(seq(0, nrow(allcond), len=seps)+1)[1:intvs]
intvends=(seq(0, nrow(allcond), len=seps))[2:seps]

mlist_coefs<-allcond

for (i in intvstarts[arg]:intvends[arg]){
 # print(i)
  tmp<-allcond[i,]
  sim<-tmp$sim
  mech<-tmp$mech
  prop<-as.numeric(tmp$prop)
  tp<-tmp$tp
  ssize<-as.numeric(tmp$ssize)
  rep<-tmp$rep
  propname<-ifelse(prop==0.1, "l", ifelse(prop==0.2, "m", "h"))
  
  mname<-paste0("sim_", sim, "_rep_", rep, "_size_", ssize, "_mech_", mech, "_prop_", propname, "_tp_", tp)

  mnet<-mlist[[mname]]

  
  
  coef<-ergmcoef(mnet$adj_matrix, mnet$va, mnet$vb, mnet$vc)
  mlist_coefs[i, "edges"]<-coef[["edges"]]
  mlist_coefs[i, "mutual"]<-coef[["mutual"]]
  mlist_coefs[i, "gwesp"]<-coef[["gwesp"]]
  mlist_coefs[i, "nodematchB"]<-coef[["nodematchB"]]
  mlist_coefs[i, "nodematchC"]<-coef[["nodematchC"]]
  mlist_coefs[i, "nodecovA"]<-coef[["nodecovA"]]
  mlist_coefs[i, "nodefactorB2"]<-coef[["nodefactorB2"]]
  mlist_coefs[i, "nodecovC"]<-coef[["nodecovC"]]
  
  
}

mlist_coefs_sep<-mlist_ciefs[intvstarts[arg]:intvends[arg],]


save(mlist_coefs_sep, file=paste0("data/seps/mlist_coefs_",arg,".RData"))



library(dplyr)
mlist_coefs_sep%>%  group_by(sim, ssize) %>% summarize(edges=mean(edges), gwesp=mean(gwesp),"mutual"=mean(mutual), "nodematchB"=mean(nodematchB), "nodematchC"=mean(nodematchC), "nodecovA"=mean(nodecovA), "nodefactorB"=mean(nodefactorB2), "nodecovC"=mean(nodecovC)) 



mlist_coefs<-data.frame()
for (i in 1:72){
  load(paste0("data/seps/mlist_coefs_",i,".RData"))
  mlist_coefs<-rbind(mlist_coefs, mlist_coefs_sep)
}


