
load("data/mlist.RData")
load("data/nlist.RData")

source("exp_funcs.R")
source("result_funcs.R")

### imputation

repnum=100
sim<-c(1:4)
rep<-c(1:repnum)
mech<-c("mcar", "mar", "mnar1", "mnar2")
prop<-c(0.1, 0.2, 0.3)
tp<-c("actor","cell","mix")
ssize<-c(50, 100)
imp_method<-c("bergm2")
imp_num<-c(1:30)

cond <-list(
  imp_num=imp_num,ssize=ssize, sim=sim, rep=rep, mech=mech, prop=prop, tp=tp, imp_method=imp_method
)

allcond <- expand.grid(cond)



arg<-as.numeric(commandArgs(trailingOnly=TRUE))

intvs=192
seps=intvs+1
intvstarts=(seq(0, nrow(allcond), len=seps)+1)[1:intvs]
intvends=(seq(0, nrow(allcond), len=seps))[2:seps]


### p is interval index
### for i in (intvstarts[p]:intvends[p])

imputed_bergm2<-list()
imputed_bergm2_avg<-list()
for (i in intvstarts[arg]:intvends[arg]){
  dens<-0
  if (i%%30==1){
    tmp<-allcond[i,]
    sim<-tmp$sim
    mech<-tmp$mech
    prop<-as.numeric(tmp$prop)
    tp<-tmp$tp
    ssize<-as.numeric(tmp$ssize)
    rep<-tmp$rep
    imp_method<-tmp$imp_method
    propname<-ifelse(prop==0.1, "l", ifelse(prop==0.2, "m", "h"))

    mname<-paste0("sim_", sim, "_rep_", rep, "_size_", ssize, "_mech_", mech, "_prop_", propname, "_tp_", tp)
    net<-mlist[[mname]]
    dens<-sum(net$adj_matrix, na.rm=T)/sum(!is.na(net$adj_matrix))
    tmp <-impute_bergm_complex(net$adj_matrix, net$va, net$vb, net$vc, 30)
    missindex<-which(is.na(net$adj_matrix))
    misslist<-matrix(0,ncol=30, nrow=length(missindex))
    for (j in imp_num){
      impname<-paste0("sim_", sim, "_rep_", rep, "_size_", ssize, "_mech_", mech, "_prop_", propname, "_tp_", tp, "_method_", imp_method, "_num_", j)
      imputed_bergm2[[impname]]<-tmp[[j]]
      misslist[,j]<-as.matrix(tmp[[j]])[missindex]
    }
    avg<-ifelse(apply(misslist, 1, sum)/30 > dens, 1,0)
    impname<-paste0("sim_", sim, "_rep_", rep, "_size_", ssize, "_mech_", mech, "_prop_", propname, "_tp_", tp, "_method_", imp_method, "_num_avg")
    newnet<-net$adj_matrix
    newnet[missindex]<-avg
    imputed_bergm2[[impname]]<-newnet
    imputed_bergm2_avg[[impname]]<-newnet
  }


}

save(imputed_bergm2, file=paste0("data/seps/imputed_bergm2_",arg,".RData"))
save(imputed_bergm2_avg, file=paste0("data/seps/imputed_bergm2_avg_",arg,".RData"))



imputed_bergm2<-list()
for (i in 1:192){
  load(paste0("data/seps/imputed_bergm2_avg_",i,".RData"))
  imputed_bergm2<-c(imputed_bergm2, imputed_bergm2_avg)
}
save(imputed_bergm2, file="data/imputed_bergm2.RData")


### network descriptive

load("data/imputed_bergm2.RData")

repnum=100
sim<-c(1:4)
rep<-c(1:repnum)
mech<-c("mcar", "mar", "mnar1", "mnar2")
prop<-c(0.1, 0.2, 0.3)
tp<-c("actor","cell","mix")
ssize<-c(50, 100)
imp_method<-c("bergm2")
imp_num<-c("avg")

cond <-list(
  ssize=ssize, sim=sim, rep=rep, mech=mech, prop=prop, tp=tp, imp_method=imp_method, imp_num=imp_num
)

allcond <- expand.grid(cond)
stats_bergm2<-allcond
for (i in 1:nrow(allcond)){
  if(i%%100==0){
    print(i)
  }
  tmp<-allcond[i,]
  sim<-tmp$sim
  mech<-tmp$mech
  prop<-as.numeric(tmp$prop)
  tp<-tmp$tp
  ssize<-as.numeric(tmp$ssize)
  rep<-tmp$rep
  imp_method<-tmp$imp_method
  imp_num<-tmp$imp_num
  propname<-ifelse(prop==0.1, "l", ifelse(prop==0.2, "m", "h"))

  mname<-paste0("sim_", sim, "_rep_", rep, "_size_", ssize, "_mech_", mech, "_prop_", propname, "_tp_", tp)
  impname<-paste0("sim_", sim, "_rep_", rep, "_size_", ssize, "_mech_", mech, "_prop_", propname, "_tp_", tp, "_method_", imp_method, "_num_", imp_num)
  nname<-paste0("sim_", sim, "_rep_", rep, "_size_", ssize)

  nnet<-nlist[[nname]]
  mnet<-mlist[[mname]]
  imputed<-imputed_bergm2[[impname]]
  
  if (sum(is.na(imputed))>0){
    stats_bergm2[i, "accuracy"] <- NA
    stats_bergm2[i, "TN"]<-NA
    stats_bergm2[i, "FN"]<-NA
    stats_bergm2[i, "FP"]<-NA
    stats_bergm2[i, "TP"]<-NA
    stats_bergm2[i, "TPR"]<-NA
    stats_bergm2[i, "TNR"]<-NA
    stats_bergm2[i, "corIn"]<-NA
    stats_bergm2[i, "corOut"]<-NA
    
    stats_bergm2[i, "reciprocity"]<-NA
    stats_bergm2[i, "density"]<-NA
    stats_bergm2[i, "transitivity"]<-NA
    stats_bergm2[i, "triangle"]<-NA
    stats_bergm2[i, "gwesp"]<-NA
    stats_bergm2[i, "homophilyA"]<-NA
    stats_bergm2[i, "homophilyB"]<-NA
    stats_bergm2[i, "homophilyC"]<-NA
  }else{
    stats_bergm2[i, "accuracy"] <- imp_acc(mnet$adj_matrix, nnet$adj_matrix, imputed)
    cm <-confusion_matrix(mnet$adj_matrix, nnet$adj_matrix, imputed)
    stats_bergm2[i, "TN"]<-cm[["TN"]]
    stats_bergm2[i, "FN"]<-cm[["FN"]]
    stats_bergm2[i, "FP"]<-cm[["FP"]]
    stats_bergm2[i, "TP"]<-cm[["TP"]]
    stats_bergm2[i, "TPR"]<-cm[["TPR"]]
    stats_bergm2[i, "TNR"]<-cm[["TNR"]]
    stats_bergm2[i, "corIn"]<-degcor(nnet$adj_matrix, imputed)[1]
    stats_bergm2[i, "corOut"]<-degcor(nnet$adj_matrix, imputed)[2]
    
    stats<-netstats(imputed, nnet$va, nnet$vb, nnet$vc)
    stats_bergm2[i, "reciprocity"]<-stats[["reciprocity"]]
    stats_bergm2[i, "density"]<-stats[["density"]]
    stats_bergm2[i, "transitivity"]<-stats[["transitivity"]]
    stats_bergm2[i, "triangle"]<-stats[["triangle"]]
    stats_bergm2[i, "gwesp"]<-stats[["gwesp"]]
    stats_bergm2[i, "homophilyA"]<-stats[["homophilyA"]]
    stats_bergm2[i, "homophilyB"]<-stats[["homophilyB"]]
    stats_bergm2[i, "homophilyC"]<-stats[["homophilyC"]]
  }



}

save(stats_bergm2, file=paste0("data/stats_bergm2.RData"))

library(dplyr)
stats_bergm2[complete.cases(stats_bergm2),] %>%  group_by(sim, ssize) %>% summarize(TPR=mean(TPR),TNR=mean(TNR), incor=mean(corIn), outcor=mean(corOut), density=mean(density),  gwesp=mean(gwesp),"reciprocity"=mean(reciprocity), homophilyA=mean(homophilyA), "homophilyB"=mean(homophilyB), "homophilyC"=mean(homophilyC)) %>% View()






# load("data/imputed_bergm2.RData")
# a<-rep(NA, 28800)
# for (i in 1:length(imputed_bergm2)){
#   a[i]=sum(is.na(imputed_bergm2[[i]]))
# }
# a[a>0]
