
load("data/mlist.RData")
load("data/nlist.RData")

source("exp_funcs.R")
source("result_funcs.R")

### imputation

# repnum=100
# sim<-c(1:4)
# rep<-c(1:repnum)
# mech<-c("mcar", "mar", "mnar1", "mnar2")
# prop<-c(0.1, 0.2, 0.3)
# tp<-c("actor","cell","mix")
# ssize<-c(50, 100)
# imp_method<-c("mice")
# imp_num<-c(1:30)
# 
# cond <-list(
#   imp_num=imp_num,ssize=ssize, sim=sim, rep=rep, mech=mech, prop=prop, tp=tp, imp_method=imp_method
# )
# 
# allcond <- expand.grid(cond)
# 
# 
# arg<-as.numeric(commandArgs(trailingOnly=TRUE))
# 
# intvs=30
# seps=intvs+1
# intvstarts=(seq(0, nrow(allcond), len=seps)+1)[1:intvs]
# intvends=(seq(0, nrow(allcond), len=seps))[2:seps]
# 
# 
# imputed_mice<-list()
# for (i in intvstarts[arg]:intvends[arg]){
#   if (i%%imp_num[length(imp_num)]==1){
#     #print(i)
#     tmp<-allcond[i,]
#     sim<-tmp$sim
#     mech<-tmp$mech
#     prop<-as.numeric(tmp$prop)
#     tp<-tmp$tp
#     ssize<-as.numeric(tmp$ssize)
#     rep<-tmp$rep
#     imp_method<-tmp$imp_method
#     #imp_num<-as.numeric(tmp$imp_num)
#     propname<-ifelse(prop==0.1, "l", ifelse(prop==0.2, "m", "h"))
#     
#     mname<-paste0("sim_", sim, "_rep_", rep, "_size_", ssize, "_mech_", mech, "_prop_", propname, "_tp_", tp)
#     
#     net<-mlist[[mname]]
#     adjlist<-makedf(net)
#     tmp <-impute_mice(adjlist)
#     dens<-sum(net$adj_matrix, na.rm=T)/sum(!is.na(net$adj_matrix))
#     missindex<-which(is.na(net$adj_matrix))
#     misslist<-matrix(0,ncol=30, nrow=length(missindex))
#     for (j in imp_num){
#       impname<-paste0("sim_", sim, "_rep_", rep, "_size_", ssize, "_mech_", mech, "_prop_", propname, "_tp_", tp, "_method_", imp_method, "_num_", j)
#       #imputed_mice[[impname]]<-as.matrix(tmp[[j]])
#       misslist[,j]<-as.matrix(tmp[[j]])[missindex]
#     }
#     avg<-ifelse(apply(misslist, 1, sum)/30>dens, 1,0)
#     impname<-paste0("sim_", sim, "_rep_", rep, "_size_", ssize, "_mech_", mech, "_prop_", propname, "_tp_", tp, "_method_", imp_method, "_num_avg")
#     newnet<-net$adj_matrix
#     newnet[missindex]<-avg
#     imputed_mice[[impname]]<-newnet
#   
#   }
# }
# 
# imputed_mice_sep=imputed_mice
# save(imputed_mice_sep, file=paste0("data/seps/imputed_mice_",arg,".RData"))
# 
# 
# 
# imputed_mice<-list()
# for (i in 1:30){
#   load(paste0("data/seps/imputed_mice_",i,".RData"))
#   imputed_mice<-c(imputed_mice, imputed_mice_sep)
# }
# save(imputed_mice, file="data/imputed_mice.RData")
# 



### network descriptive

load("data/imputed_mice.RData")

repnum=100
sim<-c(1:4)
rep<-c(1:repnum)
mech<-c("mcar", "mar", "mnar1", "mnar2")
prop<-c(0.1, 0.2, 0.3)
tp<-c("actor","cell","mix")
ssize<-c(50, 100)
imp_method<-c("mice")
imp_num<-c("avg")

cond <-list(
  ssize=ssize, sim=sim, rep=rep, mech=mech, prop=prop, tp=tp, imp_method=imp_method, imp_num=imp_num
)

allcond <- expand.grid(cond)
stats_mice<-allcond
for (i in 1700:nrow(allcond)){
  if (i%%100==0){
    print(i)
  }
  tmp<-allcond[i,]
  sim<-tmp$sim
  mech<-tmp$mech
  prop<-as.numeric(tmp$prop)
  tp<-tmp$tp
  ssize<-as.numeric(tmp$ssize)
  rep<-tmp$rep
  imp_method<-tmp$imp_method
  imp_num<-tmp$imp_num
  propname<-ifelse(prop==0.1, "l", ifelse(prop==0.2, "m", "h"))

  mname<-paste0("sim_", sim, "_rep_", rep, "_size_", ssize, "_mech_", mech, "_prop_", propname, "_tp_", tp)
  impname<-paste0("sim_", sim, "_rep_", rep, "_size_", ssize, "_mech_", mech, "_prop_", propname, "_tp_", tp, "_method_", imp_method, "_num_", imp_num)
  nname<-paste0("sim_", sim, "_rep_", rep, "_size_", ssize)

  nnet<-nlist[[nname]]
  mnet<-mlist[[mname]]
  imputed<-imputed_mice[[impname]]

  stats_mice[i, "accuracy"] <- imp_acc(mnet$adj_matrix, nnet$adj_matrix, imputed)
  cm <-confusion_matrix(mnet$adj_matrix, nnet$adj_matrix, imputed)
  stats_mice[i, "TN"]<-cm[["TN"]]
  stats_mice[i, "FN"]<-cm[["FN"]]
  stats_mice[i, "FP"]<-cm[["FP"]]
  stats_mice[i, "TP"]<-cm[["TP"]]
  stats_mice[i, "TPR"]<-cm[["TPR"]]
  stats_mice[i, "TNR"]<-cm[["TNR"]]
  stats_mice[i, "corIn"]<-degcor(nnet$adj_matrix, imputed)[1]
  stats_mice[i, "corOut"]<-degcor(nnet$adj_matrix, imputed)[2]

  stats<-netstats(imputed, nnet$va, nnet$vb, nnet$vc)
  stats_mice[i, "reciprocity"]<-stats[["reciprocity"]]
  stats_mice[i, "density"]<-stats[["density"]]
  stats_mice[i, "transitivity"]<-stats[["transitivity"]]
  stats_mice[i, "triangle"]<-stats[["triangle"]]
  stats_mice[i, "gwesp"]<-stats[["gwesp"]]
  stats_mice[i, "homophilyA"]<-stats[["homophilyA"]]
  stats_mice[i, "homophilyB"]<-stats[["homophilyB"]]
  stats_mice[i, "homophilyC"]<-stats[["homophilyC"]]


}

save(stats_mice, file="data/stats_mice.RData")

