
load("data/mlist.RData")
load("data/nlist.RData")

source("exp_funcs.R")
source("result_funcs.R")

### imputation

repnum=100
sim<-c(1:4)
rep<-c(1:repnum)
mech<-c("mcar", "mar", "mnar1", "mnar2")
prop<-c(0.1, 0.2, 0.3)
tp<-c("actor","cell","mix")
ssize<-c(50, 100)
imp_method<-c("re")
imp_num<-c(1)

cond <-list(
  ssize=ssize, sim=sim, rep=rep, mech=mech, prop=prop, tp=tp, imp_method=imp_method, imp_num=imp_num
)

allcond <- expand.grid(cond)

# intvs=4
# seps=intvs+1
# intvends=(seq(0, nrow(allcond), len=seps)+1)[1:intvs]
# intvstarts=(seq(0, nrow(allcond), len=seps))[2:seps]


### p is interval index
### for i in (intvstarts[p]:intvends[p])

imputed_re<-list()
for (i in 1:nrow(allcond)){
  tmp<-allcond[i,]
  sim<-tmp$sim
  mech<-tmp$mech
  prop<-as.numeric(tmp$prop)
  tp<-tmp$tp
  ssize<-as.numeric(tmp$ssize)
  rep<-tmp$rep
  imp_method<-tmp$imp_method
  imp_num<-as.numeric(tmp$imp_num)
  propname<-ifelse(prop==0.1, "l", ifelse(prop==0.2, "m", "h"))
  
  mname<-paste0("sim_", sim, "_rep_", rep, "_size_", ssize, "_mech_", mech, "_prop_", propname, "_tp_", tp)
  impname<-paste0("sim_", sim, "_rep_", rep, "_size_", ssize, "_mech_", mech, "_prop_", propname, "_tp_", tp, "_method_", imp_method, "_num_", imp_num)
  
  net<-mlist[[mname]]
  imputed_re[[impname]]<-impute_reconstruction(net$adj_matrix)
}

save(imputed_re, file="data/imputed_re.RData")


### network descriptive

load("data/imputed_re.RData")

repnum=100
sim<-c(1:4)
rep<-c(1:repnum)
mech<-c("mcar", "mar", "mnar1", "mnar2")
prop<-c(0.1, 0.2, 0.3)
tp<-c("actor","cell","mix")
ssize<-c(50, 100)
imp_method<-c("re")
imp_num<-c(1)

cond <-list(
  ssize=ssize, sim=sim, rep=rep, mech=mech, prop=prop, tp=tp, imp_method=imp_method, imp_num=imp_num
)

allcond <- expand.grid(cond)
stats_re<-allcond
for (i in 1:nrow(allcond)){
  tmp<-allcond[i,]
  sim<-tmp$sim
  mech<-tmp$mech
  prop<-as.numeric(tmp$prop)
  tp<-tmp$tp
  ssize<-as.numeric(tmp$ssize)
  rep<-tmp$rep
  imp_method<-tmp$imp_method
  imp_num<-as.numeric(tmp$imp_num)
  propname<-ifelse(prop==0.1, "l", ifelse(prop==0.2, "m", "h"))
  
  mname<-paste0("sim_", sim, "_rep_", rep, "_size_", ssize, "_mech_", mech, "_prop_", propname, "_tp_", tp)
  impname<-paste0("sim_", sim, "_rep_", rep, "_size_", ssize, "_mech_", mech, "_prop_", propname, "_tp_", tp, "_method_", imp_method, "_num_", imp_num)
  nname<-paste0("sim_", sim, "_rep_", rep, "_size_", ssize)
  
  nnet<-nlist[[nname]]
  mnet<-mlist[[mname]]
  imputed<-imputed_re[[impname]]
  
  stats_re[i, "accuracy"] <- imp_acc(mnet$adj_matrix, nnet$adj_matrix, imputed)
  cm <-confusion_matrix(mnet$adj_matrix, nnet$adj_matrix, imputed)
  stats_re[i, "TN"]<-cm[["TN"]]
  stats_re[i, "FN"]<-cm[["FN"]]
  stats_re[i, "FP"]<-cm[["FP"]]
  stats_re[i, "TP"]<-cm[["TP"]]
  stats_re[i, "TPR"]<-cm[["TPR"]]
  stats_re[i, "TNR"]<-cm[["TNR"]]
  stats_re[i, "corIn"]<-degcor(nnet$adj_matrix, imputed)[1]
  stats_re[i, "corOut"]<-degcor(nnet$adj_matrix, imputed)[2]
  
  stats<-netstats(imputed, nnet$va, nnet$vb, nnet$vc)
  stats_re[i, "reciprocity"]<-stats[["reciprocity"]]
  stats_re[i, "density"]<-stats[["density"]]
  stats_re[i, "transitivity"]<-stats[["transitivity"]]
  stats_re[i, "triangle"]<-stats[["triangle"]]
  stats_re[i, "gwesp"]<-stats[["gwesp"]]
  stats_re[i, "homophilyA"]<-stats[["homophilyA"]]
  stats_re[i, "homophilyB"]<-stats[["homophilyB"]]
  stats_re[i, "homophilyC"]<-stats[["homophilyC"]]
  
  
}

save(stats_re, file="data/stats_re.RData")

