source("net_sim_funcs.R")


repnum=100
sim<-c(1:4)
rep<-c(1:repnum)
mech<-c("mcar", "mar", "mnar1", "mnar2")
prop<-c(0.1, 0.2, 0.3)
tp<-c("actor","cell","mix")
ssize<-c(50, 100)



coefs<-list(
  c(-2, 2, 0, 0, 0, 0, 0, 0),
  c(-3, 2, 0, 0.8, 0.8, 0, 0, 0),
  c(-8, 2, 0, 0.8, 0.8, 0.1, 0.1, 0.1),
  c(-8, 2, 0.15, 0.8, 0.8, 0.1, 0.1, 0.1)
)

nlist<-list()

cond2 <-list(
  ssize=ssize, sim=sim
)

allcond2 <- expand.grid(cond2)


for (i in 1:nrow(allcond2)){
  print(i)
  tmp<-allcond2[i,]
  sim<-tmp$sim
  ssize<-tmp$ssize
  
  tmp <- ergm_sim(ssize, coefs[[sim]],repnum)

  for (j in 1:repnum){
    lname<-paste0("sim_", sim, "_rep_", j, "_size_",ssize)
    nlist[[lname]]<-tmp[[j]]
  }
  
}

save(nlist,file="data/nlist.RData")




load("data/nlist.RData")



repnum=100
sim<-c(1:4)
rep<-c(1:repnum)
mech<-c("mcar", "mar", "mnar1", "mnar2")
prop<-c(0.1, 0.2, 0.3)
tp<-c("actor","cell","mix")
ssize<-c(50, 100)


cond <-list(
  ssize=ssize, sim=sim, rep=rep, mech=mech, prop=prop, tp=tp
)

allcond <- expand.grid(cond)

mlist<-list()



for (i in 1:nrow(allcond)){
  #print(i)
  tmp<-allcond[i,]
  sim<-tmp$sim
  mech<-tmp$mech
  prop<-as.numeric(tmp$prop)
  tp<-tmp$tp
  ssize<-as.numeric(tmp$ssize)
  rep<-tmp$rep
  
  propname<-ifelse(prop==0.1, "l", ifelse(prop==0.2, "m", "h"))
  
  lname<-paste0("sim_", sim, "_rep_", rep, "_size_", ssize)
  mname<-paste0("sim_", sim, "_rep_", rep, "_size_", ssize, "_mech_", mech, "_prop_", propname, "_tp_", tp)

  tmp <- nlist[[lname]]
  mnet<-tmp
  

  if (tp=="actor"){
    if (mech=="mcar"){
     # print(prop)
      mnet[["adj_matrix"]]<-mcar_actor_missing(ssize, prop,tmp[["adj_matrix"]])
    }else if (mech=="mar"){
      mnet[["adj_matrix"]]<-mar_actor_missing(ssize, prop,tmp[["adj_matrix"]], tmp[["vb"]])
    }else if (mech=="mnar1"){
      mnet[["adj_matrix"]]<-mnar_actor_missing1(ssize, prop,tmp[["adj_matrix"]])
    }else{
      mnet[["adj_matrix"]]<-mnar_actor_missing2(ssize, prop,tmp[["adj_matrix"]])
    }
  }else if (tp=="cell"){
    if (mech=="mcar"){
      mnet[["adj_matrix"]]<-mcar_cell_missing(ssize, prop,tmp[["adj_matrix"]])
    }else if (mech=="mar"){
      mnet[["adj_matrix"]]<-mar_cell_missing(ssize, prop,tmp[["adj_matrix"]], tmp[["vb"]])
    }else if (mech=="mnar1"){
      mnet[["adj_matrix"]]<-mnar_cell_missing1(ssize, prop,tmp[["adj_matrix"]])
    }else{
      mnet[["adj_matrix"]]<-mnar_cell_missing2(ssize, prop,tmp[["adj_matrix"]])
    }
  }else{
    if (mech=="mcar"){
      mnet[["adj_matrix"]]<-mcar_mix_missing(ssize, prop,0.5, tmp[["adj_matrix"]])
    }else if (mech=="mar"){
      mnet[["adj_matrix"]]<-mar_mix_missing(ssize, prop,0.5,tmp[["adj_matrix"]], tmp[["vb"]])
    }else if (mech=="mnar1"){
      mnet[["adj_matrix"]]<-mnar_mix_missing1(ssize, prop,0.5,tmp[["adj_matrix"]])
    }else{
      mnet[["adj_matrix"]]<-mnar_mix_missing2(ssize, prop,0.5,tmp[["adj_matrix"]])
    }
  }
 
  mlist[[mname]]<-mnet
  

}

save(mlist, file="data/mlist.RData")

load("data/mlist.RData")
ll<-rep(0, nrow(allcond))
for (i in 1:nrow(allcond)){
  ll[i] = sum(is.na(mlist[[i]][["adj_matrix"]]))
}

unique(ll)
